import { IStateTreeNode } from "mobx-state-tree";
export interface WithAsyncStorageOptions {
    key?: string;
    autoSave?: boolean;
    only?: string | string[];
    except?: string | string[];
    onLoad?: (loaded: object | undefined) => Promise<object | undefined> | {} | undefined;
    onSave?: (snapshot: object) => Promise<object | undefined> | object | undefined;
}
export declare const withAsyncStorage: (options?: WithAsyncStorageOptions) => (self: IStateTreeNode) => {
    actions: {
        load: () => Promise<any | undefined>;
        save: () => Promise<void>;
        beforeDetach(): void;
    };
};
